<script>
import { mapState } from 'vuex';

import * as helperFilters from '~/helpers/filters.js';

import AppSearchBar from '~/components/ui/app-search-bar.vue';
import UserDropdown from '~/components/ui/user-dropdown.vue';

export default {
  name: `app-bar`,
  components: { AppSearchBar, UserDropdown },
  props: {
    projects: { type: Array, required: true },
  },
  data() {
    return {
      showUserDropdown: false,
    }
  },
  computed: {
    ...mapState({
      currentProject: (state) => state.projects.currentProject,
    }),
    appTitle() {
      return `Colibri`;
    },
    appVersion() {
      return process.env.APP_VERSION;
    },
    projectItems() {
      if (!this.projects) return [];
      return this.projects.map(p => ({ text: p.name, value: p.id }));
    }
  },
  filters: {
    uppercase: helperFilters.uppercase,
  },
  methods: {
    async setCurrentProject(id) {
      await this.$store.commit(`projects/setCurrentProject`, { id, vue: this });
    },
    closeUserDropdown() {
      this.showUserDropdown = false;
    },
  },
}
</script>

<template>
  <v-app-bar app dense>
    <v-app-bar-nav-icon>
      <nuxt-link :to="{ path: localePath(`/`), query: $route.query }">
        <img src="/logo.png" height="30" width="auto" />
      </nuxt-link>
    </v-app-bar-nav-icon>
    <v-app-bar-title>
      <v-row align="baseline" no-gutters>
        <div class="text-h5">{{ appTitle }}</div>
        <div class="ml-2 text-subtitle-1 grey--text">• v{{ appVersion }}</div>
      </v-row>
    </v-app-bar-title>
    <template v-if="currentProject">
      <v-divider vertical class="mx-4" />
      <v-select :items="projectItems" :value="currentProject" @input="setCurrentProject" outlined dense hide-details />
      <v-divider vertical class="mx-4" />
      <v-row no-gutters>
        <nuxt-link :to="{ path: localePath(`/anim-rig`), query: $route.query }">
          <div class="ma-0">{{ $t(`app-bar.menus.anim-rig`) | uppercase }}</div>
        </nuxt-link>
      </v-row>
    </template>
    <v-spacer />
    <app-search-bar />
    <v-spacer />
    <v-row class="flex-grow-0" no-gutters>
      <v-btn icon :to="{ path: localePath(`/admin`), query: $route.query }" nuxt>
        <v-icon>mdi-cog</v-icon>
      </v-btn>
      <user-dropdown />
    </v-row>
  </v-app-bar>
</template>
